'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

require('./keyboard.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Keyboard = function (_React$Component) {
  (0, _inherits3.default)(Keyboard, _React$Component);

  function Keyboard(props) {
    (0, _classCallCheck3.default)(this, Keyboard);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Keyboard.__proto__ || (0, _getPrototypeOf2.default)(Keyboard)).call(this, props));

    _this.defaultState = {
      inputFieldIndex: null,
      show: false,
      skin: null,
      symbol: '.',
      height: '50%',
      onKeyDown: null
    };

    _this.deleteTimer = null;
    _this.deleteDelayTimer = null;
    _this.stateUpdateTimer = null;
    _this.state = _this.defaultState;

    return _this;
  }

  (0, _createClass3.default)(Keyboard, [{
    key: 'componentDidMount',
    value: function componentDidMount() {

      // 阻止页面滚动
      this.refs.keyboard.addEventListener('touchstart', this.disableKeyboardTouch.bind(this), false);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {

      clearTimeout(this.deleteTimer);
      clearTimeout(this.deleteDelayTimer);
      clearTimeout(this.stateUpdateTimer);
      this.refs.keyboard.removeEventListener('touchstart', this.disableKeyboardTouch.bind(this), false);
    }
  }, {
    key: 'render',
    value: function render() {
      var _state = this.state,
          inputFieldIndex = _state.inputFieldIndex,
          show = _state.show,
          height = _state.height,
          skin = _state.skin,
          symbol = _state.symbol;


      var keyboardClassName = 'number-input-keyboard ' + skin;
      var symbolButtonClassName = symbol ? '' : 'disabled';

      if (show) {
        keyboardClassName = keyboardClassName + ' active';
      }

      return _react2.default.createElement(
        'div',
        { ref: 'keyboard', 'data-number-input-index': inputFieldIndex, style: { height: height }, className: keyboardClassName },
        _react2.default.createElement(
          'button',
          { 'data-number-input-index': inputFieldIndex, onTouchStart: this.handleInput.bind(this), 'data-value': '1' },
          '1'
        ),
        _react2.default.createElement(
          'button',
          { 'data-number-input-index': inputFieldIndex, onTouchStart: this.handleInput.bind(this), 'data-value': '2' },
          '2'
        ),
        _react2.default.createElement(
          'button',
          { 'data-number-input-index': inputFieldIndex, onTouchStart: this.handleInput.bind(this), 'data-value': '3' },
          '3'
        ),
        _react2.default.createElement(
          'button',
          { 'data-number-input-index': inputFieldIndex, onTouchStart: this.handleInput.bind(this), 'data-value': '4' },
          '4'
        ),
        _react2.default.createElement(
          'button',
          { 'data-number-input-index': inputFieldIndex, onTouchStart: this.handleInput.bind(this), 'data-value': '5' },
          '5'
        ),
        _react2.default.createElement(
          'button',
          { 'data-number-input-index': inputFieldIndex, onTouchStart: this.handleInput.bind(this), 'data-value': '6' },
          '6'
        ),
        _react2.default.createElement(
          'button',
          { 'data-number-input-index': inputFieldIndex, onTouchStart: this.handleInput.bind(this), 'data-value': '7' },
          '7'
        ),
        _react2.default.createElement(
          'button',
          { 'data-number-input-index': inputFieldIndex, onTouchStart: this.handleInput.bind(this), 'data-value': '8' },
          '8'
        ),
        _react2.default.createElement(
          'button',
          { 'data-number-input-index': inputFieldIndex, onTouchStart: this.handleInput.bind(this), 'data-value': '9' },
          '9'
        ),
        _react2.default.createElement(
          'button',
          { 'data-number-input-index': inputFieldIndex, onTouchStart: this.handleInput.bind(this), className: symbolButtonClassName, 'data-value': symbol },
          symbol
        ),
        _react2.default.createElement(
          'button',
          { 'data-number-input-index': inputFieldIndex, onTouchStart: this.handleInput.bind(this), 'data-value': '0' },
          '0'
        ),
        _react2.default.createElement('button', { 'data-number-input-index': inputFieldIndex, onTouchStart: this.handleDeleteStart.bind(this), onTouchEnd: this.handleDeleteEnd.bind(this), 'data-value': 'delete' })
      );
    }
  }, {
    key: 'show',
    value: function show(props) {

      clearTimeout(this.deleteTimer);
      clearTimeout(this.deleteDelayTimer);
      clearTimeout(this.stateUpdateTimer);
      this.setState((0, _extends3.default)({}, props, { show: true }));
    }
  }, {
    key: 'hide',
    value: function hide() {
      var _this2 = this;

      this.setState({
        show: false,
        height: this.defaultState.height
      });

      this.stateUpdateTimer = setTimeout(function () {
        _this2.setState(_this2.defaultState);
      }, 100);
    }
  }, {
    key: 'handleInput',
    value: function handleInput(event) {

      var value = event.target.dataset.value;
      this.state.onKeyDown && this.state.onKeyDown(value);
    }
  }, {
    key: 'handleDeleteStart',
    value: function handleDeleteStart(event) {
      var _this3 = this;

      this.state.onKeyDown && this.state.onKeyDown('delete');

      this.deleteDelayTimer = setTimeout(function () {
        _this3.deleteTimer = setInterval(function () {
          _this3.state.onKeyDown && _this3.state.onKeyDown('delete');
        }, 100);
      }, 800);
    }
  }, {
    key: 'handleDeleteEnd',
    value: function handleDeleteEnd() {
      clearTimeout(this.deleteTimer);
      clearTimeout(this.deleteDelayTimer);
    }
  }, {
    key: 'disableKeyboardTouch',
    value: function disableKeyboardTouch(e) {
      e.preventDefault();
    }
  }]);
  return Keyboard;
}(_react2.default.Component);

exports.default = Keyboard;
//# sourceMappingURL=keyboard.js.map